2008-12-08  Thomas Schwinge  <tschwinge@gnu.org>

	* Makefile: Rework, so that dependency tracking is done for all files.

	* Makefile (HURDLIBS): Add ihash and shouldbeinlibc.

2007-11-13  Thomas Schwinge  <tschwinge@gnu.org>

	* trans.c (netfs_attempt_utimes): Adapt to ``struct stat'' changes.

2007-05-08  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	* vga-support.c (vga_fini): Fix call to ioperm().
	* generic-speaker.c (generic_speaker_start): Call ioperm() on GNU Mach
	1 too.

2005-07-13  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	* current-vcs.c (repeater_node): Set default.

2005-07-11  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	* Makefile (modules): Add `current-vcs' and its rules.
	* console.c (console_current_id): New function.
	* input.h (console_current_id): New prototype.
	* trans.c (struct netnode): New member `symlink_path'.
	(console_demuxer): Handle case when node it anonymous.
	(netfs_S_io_select): Likewise.
	(netfs_S_io_read): Likewise.
	(netfs_S_io_write): Likewise.
	(netfs_report_access): Likewise.
	(netfs_attempt_mksymlink): Implement symlinks.
	(netfs_attempt_lookup): Likewise.
	(netfs_attempt_unlink): Likewise.
	(netfs_attempt_link): Likewise.
	(netfs_attempt_mkfile): Likewise.
	(netfs_attempt_readlink): Likewise.
	(netfs_get_dirents): Likewise.
	(netfs_create_consnode): Likewise.
	* trans.h (struct consnode): New members `readlink' and `mksymlink'.
	* current-vcs.c: New file.

2005-01-10  Alfred M. Szmidt  <ams@gnu.org>

	* console.c (consnode_path): Renamed to ...
	(console_node): ... this.  Updated all references.

2005-01-06  Marco Gerards  <metgerards@student.han.nl>

	* Makefile (SRCS): Add `trans.c'.
	(LCLHDRS): Add `mach-inputdev.h'.
	(HURDLIBS): Add `netfs', `fshelp' and `iohelp'.
	(modules): Add `pc_mouse'.
	(pc_kbd.so.$(hurd-version)): Add `kdioctlServer.o' and
	`kbd-repeat.c'.
	(pc_mouse.so.$(hurd-version)): New variable.
	* console.c: Include <trans.h>.
	(DEFAULT_CONSOLE_NODE): New macro.
	(saved_id, saved_cons, consnode_path): New variables.
	(console_move_mouse): New function.
	(console_switch_away): New function.
	(console_switch_back): Likewise.
	(cons_vcons_set_mousecursor_pos): Likewise.
	(cons_vcons_set_mousecursor_status): Likewise.
	(options): Add the option `--console-node'.
	(parse_opt): Parse the options that were added to `options'.
	(main): Setup the console client translator node.
	* display.h (display_ops): New members `set_mousecursor_pos' and
	`set_mousecursor_status'.
	* driver.c (driver_start): Change the type of `i' to `unsigned
	int'.
	* driver.h (driver_ops): New members `save_status' and
	`restore_status'.
	* input.h (console_switch_away): New prototype.
	(console_switch_back): Likewise.
	(console_move_mouse): Likewise.
	* kbd-repeat.c: New file.
	* mach-inputdev.h: Likewise.
	* pc-mouse.c: Likewise.
	* trans.c: Likewise.
	* trans.h: Likewise.
	* pc-kbd.c: Include <argp.h> and "mach-inputdev.h".
	(DEFAULT_REPEATER_NODE): New macro.
	(repeater_node, cnode): New variables.
	(kev_type, mouse_motion, Scancode, m_deltaX, m_deltaY, MOUSE_LEFT)
	(MOUSE_MIDDLE, MOUSE_RIGHT, MOUSE_MOTION, KEYBD_EVENT)
	(IOCPARM_MASK, IOC_OUT, IOC_IN, _IOC, _IOR, _IOW, KDSKBDMODE,
	(KB_EVENT, KB_ASCII, KDGKBDTYPE, KB_VANILLAKB, KDSETLEDS):
	Removed.
	(gnumach_v1_input_next): Call the repeater when repeating is
	active.
	(doc, options, argp): New variables.
	(parse_opt): New function.
	(pc_kbd_init): Function rewritten.
	(pc_kbd_start): Initialize the repeater, when it is active.
	(pc_kbd_fini): Destroy the console node.
	* vga.c (vga_mousecursor): New struct.
	(vga_mousecursor_t): New type.
	(mousecursor): New variable.
	(hide_mousecursor): New function.
	(draw_mousecursor): Likewise.
	(vga_display_restore_status): Likewise.
	(vga_display_update): Likewise.
	(vga_set_mousecursor_pos): Likewise.
	(vga_set_mousecursor_status): Likewise.
	(vga_display_scroll): Update the mousecursor state.
	(driver_vga_ops): Add `vga_display_restore_status'.
	(vga_display_op): Add `vga_display_update', `vga_set_mousecursor_pos'
	and `vga_set_mousecursor_status'.

2004-11-15  Marcus Brinkmann  <marcus@gnu.org>

	* pc-kbd.c (input_loop): Make the left shift key behave the same
	as right shift key with regards to page up/down.

2004-10-22  Marcus Brinkmann  <marcus@gnu.org>

	* driver.c (driver_start): Don't underflow I.

2004-09-29  Alfred M. Szmidt  <ams@kemisten.nu>

	* Makefile (vga-CPPFLAGS): New variable.

	* vga.c (DEFAULT_VGA_FONT, DEFAULT_VGA_FONT_ITALIC)
	(DEFAULT_VGA_FONT_BOLD, DEFAULT_VGA_FONT_BOLD_ITALIC): Use
	`DEFAULT_VGA_FONT_DIR' instead of hardcoding the filename.

2004-03-21  Marco Gerards  <metgerards@student.han.nl>

	* console.c (main): Make sure the arguments are	parsed in order.
	* driver.c (driver_add):  Set up argc and argv so they can be used
	by argp.
	* generic-speaker.c: Include <string.h> and <argp.h>.
	(struct melody): New member `name'.  Every melody was given a
	name.
	(BELL_CLASSIC, BELL_LINUX, BELL_ALARM, BELL_CMAJOR): New macros.
	(doc, options, argp): New variables.
	(parse_opt): New function.
	(generic_speaker_init): Parse the arguments using argp.
	* vga.c (doc, options, argp): New variables.
	(parse_opt): New function.
	(parse_startup_args): Function removed.
	(vga_display_init): Use argp_parse instead of parse_startup_args.

2004-03-07  Marco Gerards  <metgerards@student.han.nl>

	* bdf.c (bdf_read): Change the types of has_size, has_fbbx,
	has_metricset, glyph_has_encoding, glyph_has_bbx, glyph_bwidth,
	glyph_bheight and glyph_blines to unsigned int.
	* bell.h (struct bell_ops): Change the type of the argument KEY of
	the interface `deprecated' to unsigned int.  All callers changed.
	* display.h (struct display_ops): Changed the type of the
	arguments width and height to unsigned int.  All callers changed.
	* driver.c (driver_fini): Change the type of `i' to unsigned int
	to silence a gcc warning.
	(driver_start): Likewise.
	(driver_remove): Likewise.
	(ADD_REMOVE_COMPONENT): Likewise.
	(driver_add): Likewise.
	* generic-speaker.c (beep_on): Cup pitch at 20000, not 327677.
	Also silences a gcc warning.
	* ncursesw.c: Changed all calls to the function `ncurses_refresh'
	to `refresh_screen'.
	(current_width): Changed type to unsigned int.
	(current_height): Likewise.
	(padx): Likewise.
	(pady): Likewise.
	(refresh_screen): Cast LINES and COLS to unsigned int.
	(input_loop): Change `i' from int to unsigned int to silence a gcc
	warning.
	* vga.c (current_width): Changed type to unsigned int to silence a
	gcc warning.
	(current_heigh): Likewise.
	(struct vga_display): Changed the type of the members `width' and
	`height' to unsigned int to silence a gcc warning.
	(vga_display_change_font): Disabled the unused code for now.

2003-08-17  Marcus Brinkmann  <marcus@gnu.org>

	* vga-dynafont.c: Include <stddef.h>.
	(struct mapped_character): Change type of LOCP to
	hurd_ihash_locp_t.
	(struct dynafont): Change type of CHARMAP to struct hurd_ihash.
	(dynafont_new): Use hurd_ihash_init instead of ihash_create.
	Remove variable ERR.  Call hurd_ihash_add instead of ihash_add.
	(dynafont_free): Call hurd_ihash_destroy, no ihash_free.
	(dynafont_lookup_internal): Use hurd_ihash_find, not ihash_find.
	(dynafont_lookup_internal): Call hurd_ihash_locp_remove instead
	ihash_locp_remove, and hurd_ihash_add instead ihash_add.
	(dynafont_change_font): Likewise.  Clean out LOCP if character is
	unmapped.	

2004-02-02  Marco Gerards  <metgerards@student.han.nl>

	* pc-kbd.c (KDSETLEDS): New macro.
	(update_leds): Add support for setting the keyboard LED state on
	GNUMach 1.x (> 1.3).
	(input_loop): Use size_t for `nr' instead of int to silence a gcc
	warning.

2003-08-11  Marco Gerards  <metgerards@student.han.nl>

	* console.c (cons_vcons_set_dimension): New function.
	* display.h (display_ops): New interface set_dimension.
	* ncursesw.c (ncursesw_set_dimension): New function.
	(ncursesw_displ): Add ncursesw_set_dimension.
	(ncurses_lock): Make variable static.
	(current_width): New variable.
	(current_height): Likewise.
	(cursor_state): Likewise.
	(cursor_hidden): Likewise.
	(driver_ncursesw_ops): Added ncursesw_set_dimension.
	* vga.c (current_width): New variable.
	(current_height): Likewise.
	(vga_display_set_cursor_status): If the cursor is outside the
	screen, don't change the visibility.
	(vga_display_set_cursor_pos): Don't set the cursor outside the
	physical screen.  Update cursor_hidden and hide/unhide
	to match cursor_hidden.  Function moved to above
	vga_display_set_cursor_status.
	(vga_display_scroll): Report an error when scrolling is not
	possible.
	(vga_display_clear): Recalculate cols, rows and length.
	(vga_display_write): Make it wrap around the edge.
	(vga_set_dimension): New function.
	(vga_disp_ops): Added vga_set_dimension.

	* ncursesw.c (conspad): New variable.
	(padx): Likewise.
	(pady): Likewise.
	(autoscroll): Likewise.
	(refresh_screen): new function.
	(input_loop): Use conspad instead of (the default) stdscr.
	Call console_exit instead of exiting here.  Add keybindings
	'j, 'k', 'l' and 'i' to scroll the console, add keybinding 'a'
	to switch autoscroll.
	(mvwputsn): Use conspad instead of (the default) stdscr.
	(ncursesw_scroll): Likewise.
	(ncursesw_write): Likewise.
	(ncursesw_driver_start): Likewise. Initialize conspad.
	(ncursesw_update): Call refresh_screen to refresh the console.
	(ncursesw_set_cursor_pos): Use conspad instead of (the default)
	stdscr.  Make the console autoscroll.

	* ncursesw.c (ncursesw_driver_start): Remove endwin call at
	the end of the function.

	* ncursesw.c (ncursesw_set_cursor_status): If the status can
	not be set, use another status that can sanely be used instead
	of the unavailable status.

2003-07-14  Marco Gerards  <metgerards@student.han.nl>

	* vga.c: New global variable vga_display_max_glyphs.
	(parse_startup_args): New macro PARSE_FONT_OPT_NOARGS.
	(parse_startup_args): Parse "--max-colors" and "--max-glyphs".
	(vga_display_init): Set disp->df_size to match the color setting.

2003-02-24  Marco Gerards <metgerards@student.han.nl>

	* pc-kbd.c (sc_set1_to_set2): Map the set2 scancodes for F11 and
	F12 properly on the set1 scancodes for F11 and F12.

2002-11-25  Marcus Brinkmann  <marcus@gnu.org>

	* pc-kbd.c (IS_FUNC_KEY): Fix last change.

2002-11-21  Marco Gerards  <metgerards@student.han.nl>

	* pc-kbd.c (IS_FUNC_KEY): New macro.
	(input_loop): Replaced code for set1 for console switching by set2
	code.  Also accept F11 and F12.

2002-11-18  Marcus Brinkmann  <marcus@gnu.org>

	* console.c (main): Pass ERR to error invocation.
	* generic-speaker.c (generic_spaker_beep): Use currently active
	beep's next pointer, instead index 0.
	* pc-kbd.c: New global variables led_state and gnumach_v1_compat.
	(enum scancode): Change to set 2 encoding.
	(enum scancode_x1): Likewise.
	(enum scancode_x2): New type.
	(sc_to_kc): Change to set 2 encoding.
	(sc_x1_to_kc): Likewise.
	(sc_set1_to_set2): New variable.
	(sc_set1_to_set2_x1): Likewise.
	(gnumach_v1_input_next): New function.
	(update_leds): Likewise.
	(input_next): Likewise.
	(input_loop): Use input_next or gnumach_v1_input_next to read next
	key code.
	(pc_kbd_start): Add support for current GNU Mach @>=kbd interface.
	Call update_leds and toggle led_state.
	(pc_kbd_fini): Add support for current GNU Mach.
	(pc_kbd_set_scroll_lock_status): Toggle led_state and call
	update_leds.
	* vga-support.c (vga_init): Add support for current GNU Mach's I/O
	permission bitmap handling and its mem device.

2002-09-30  Marcus Brinkmann  <marcus@gnu.org>

	* vga-support.c (vga_get_font_width): New function.
	* vga-support.h: Add prototype for vga_get_font_width.
	* vga-dynafont.c (create_system_font): Call vga_get_font_width to
	determine real font width.

2002-09-22  Marcus Brinkmann  <marcus@gnu.org>

	* pc-kbd.c (sc_to_kc): Implement Meta-Backspace combinations.

2002-09-19  Marcus Brinkmann  <marcus@gnu.org>

	* vga-support.c (vga_read_write_font_buffer): New function.  It
	turns out that reading and writing needs the same register
	settings.
	(vga_write_font_buffer): Implement in terms of
	vga_read_write_font_buffer.
	(vga_read_font_buffer): Likewise.

2002-09-18  Marcus Brinkmann  <marcus@gnu.org>

	* ncursesw.c: Add an entry for the clear function.

	* pc-kbd.c (sv_to_kc): Add entries for unused scan codes 0x55 and
	0x56.

2002-09-17  Marcus Brinkmann  <marcus@gnu.org>

	* pc-kbd.c (input_loop): Move code that toggles NumLock after code
	that handles direct entry of character codes with RightAlt.

2002-09-17  Marcus Brinkmann  <marcus@gnu.org>

	* Makefile, bdf.c, bdf.h, bell.h, console.c, display.h, driver.c,
	driver.h, generic-speaker.c, input.h, pc-kbd.c, timer.c, timer.h,
	unicode.h, vga.c, vga-dynacolor.c, vga-dynacolor.h, vga-dynafont.c,
	vga-dynafont.h, vga-hw.h, vga-support.c, vga-support.h: New file.
